blob: 7f5c862461383c0d067f9ab017dd56b8cde390f4 [file] [log] [blame]
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01001# SPDX-License-Identifier: GPL-2.0
Emese Revfy6b90bd42016-05-24 00:09:38 +02002ifdef CONFIG_GCC_PLUGINS
3 __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
4 PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
5
Emese Revfy543c37c2016-05-24 00:11:37 +02006 SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
7
Emese Revfy0dae7762016-05-24 00:10:35 +02008 gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
Emese Revfy543c37c2016-05-24 00:11:37 +02009
Emese Revfy38addce2016-06-20 20:41:19 +020010 gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so
11 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN
Andrew Donnellan7b4010e2016-12-06 17:27:58 +110012 ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY
Emese Revfy38addce2016-06-20 20:41:19 +020013 DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable
14 endif
15
Emese Revfy543c37c2016-05-24 00:11:37 +020016 ifdef CONFIG_GCC_PLUGIN_SANCOV
Masahiro Yamada642ef992018-04-13 14:06:10 +090017 ifeq ($(strip $(CFLAGS_KCOV)),)
Emese Revfy543c37c2016-05-24 00:11:37 +020018 # It is needed because of the gcc-plugin.sh and gcc version checks.
19 gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
20
21 ifneq ($(PLUGINCC),)
22 CFLAGS_KCOV := $(SANCOV_PLUGIN)
23 else
24 $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
25 endif
26 endif
27 endif
28
Kees Cookc61f13e2017-01-13 11:14:39 -080029 gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += structleak_plugin.so
30 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE) += -fplugin-arg-structleak_plugin-verbose
Ard Biesheuvelf7dd2502017-08-06 12:06:27 +010031 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_BYREF_ALL) += -fplugin-arg-structleak_plugin-byref-all
Kees Cookc61f13e2017-01-13 11:14:39 -080032 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += -DSTRUCTLEAK_PLUGIN
33
Kees Cook313dd1b62017-05-05 23:37:45 -070034 gcc-plugin-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += randomize_layout_plugin.so
35 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += -DRANDSTRUCT_PLUGIN
36 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode
37
Emese Revfy65d59ec2016-06-20 20:40:24 +020038 GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
Emese Revfy6b90bd42016-05-24 00:09:38 +020039
Emese Revfy38addce2016-06-20 20:41:19 +020040 export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
41 export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN
Emese Revfy6b90bd42016-05-24 00:09:38 +020042
Kees Cooked58c0e2016-06-17 23:11:12 -070043 ifneq ($(PLUGINCC),)
Emese Revfy543c37c2016-05-24 00:11:37 +020044 # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
45 GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
Emese Revfy6b90bd42016-05-24 00:09:38 +020046 endif
47
48 KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
49 GCC_PLUGIN := $(gcc-plugin-y)
Emese Revfycaefd8c2016-06-26 17:38:20 +020050 GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
Emese Revfy6b90bd42016-05-24 00:09:38 +020051endif
Kees Cooked58c0e2016-06-17 23:11:12 -070052
53# If plugins aren't supported, abort the build before hard-to-read compiler
54# errors start getting spewed by the main build.
55PHONY += gcc-plugins-check
56gcc-plugins-check: FORCE
57ifdef CONFIG_GCC_PLUGINS
58 ifeq ($(PLUGINCC),)
59 ifneq ($(GCC_PLUGINS_CFLAGS),)
Andrew Donnellan65c059bc2016-12-06 17:28:00 +110060 # Various gccs between 4.5 and 5.1 have bugs on powerpc due to missing
61 # header files. gcc <= 4.6 doesn't work at all, gccs from 4.8 to 5.1 have
62 # issues with 64-bit targets.
63 ifeq ($(ARCH),powerpc)
64 ifeq ($(call cc-ifversion, -le, 0501, y), y)
65 @echo "Cannot use CONFIG_GCC_PLUGINS: plugin support on gcc <= 5.1 is buggy on powerpc, please upgrade to gcc 5.2 or newer" >&2 && exit 1
66 endif
67 endif
Kees Cooked58c0e2016-06-17 23:11:12 -070068 ifeq ($(call cc-ifversion, -ge, 0405, y), y)
69 $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
70 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
71 else
72 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
73 endif
74 endif
75 endif
76endif
77 @:
78
79# Actually do the build, if requested.
80PHONY += gcc-plugins
81gcc-plugins: scripts_basic gcc-plugins-check
82ifdef CONFIG_GCC_PLUGINS
83 $(Q)$(MAKE) $(build)=scripts/gcc-plugins
84endif
85 @: